import Parse from '../parse';
import { addEvent } from '../helpers';

class MobileRich extends Parse {
  constructor(option = { platform: 'mobile' }) {
    super(option);
    this.images = [];
    this.lazyLoad = true;
    this.unbindImageEvents = () => {};
    this.clientHeight = 0;
  }

  renderImage(props) {
    let { width, height } = props;
    const paddingTop = (height / width) * 100 + '%';
    return `<div><div><div style="padding-top: ${paddingTop};"></div><img data-src="${
      props.url
    }"></div>${
      props.desc && props.desc !== '' ? `<span>${props.desc}</span>` : ''
    }</div>`;
  }

  renderLink(props) {
    // return `<p><a href="${props.url}" target="_blank">${props.text}</a></p>`;
    return `<a href="${props.route.webURL}" target="_blank">${props.content}</a>`;
  }
}

export default MobileRich;
