import Parse from '../parse';
import { computedImageSize } from '../helpers';

class WebRich extends Parse {
  constructor(option) {
    super(option);
    this.platform = option.platform;
    this.containerWidth = option.width;
  }

  renderImage(props) {
    const { width, height } = computedImageSize(
      +props.width,
      +props.height,
      this.containerWidth
    );
    return `<p><img style="width:${width}px;height:${height}px" src="${
      props.url
    }">${
      props.desc && props.desc !== '' ? `<span>${props.desc}</span>` : ''
    }</p>`;
  }

  renderLink(props) {
    return `<a href="${props.route.webURL}" target="_blank">${props.content}</a>`;
  }
}

export default WebRich;
