export const tap = function(el, func, delay) {
  var startTime = 0;
  var moving = false;
  var isTap = false;
  var delayTime = delay || 500;
  var startClientX = 0;
  var startClientY = 0;

  el.addEventListener('touchstart', function(e) {
    startTime = e.timeStamp;
    var touches = e.touches[0];
    var startClientX = touches.clientX;
    var startClientY = touches.clientY;
    moving = true;
    isTap = true;
  });

  el.addEventListener('touchmove', function(e) {
    moving = true;
    var touches = e.touches[0];
    var clientX = touches.clientX;
    var clientY = touches.clientY;

    if (
      Math.abs(startClientX - clientX) > 15 ||
      Math.abs(startClientY - clientY) > 15
    ) {
      isTap = false;
    }
  });

  el.addEventListener('touchend', function(e) {
    var endTime = e.timeStamp;
    if (moving && isTap && endTime - startTime < delayTime) {
      func(e);
    }
    moving = false;
    isTap = false;
    startTime = 0;
  });
};
